import java.io.*;
import java.util.*;
import javax.vecmath.*;
//import javax.media.j3d.*;
/*
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.picking.behaviors.*;
import com.sun.j3d.utils.picking.*;
*/

//import java.lang.RuntimeException;

/*
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.applet.Applet;
*/

public class SubdivisionControllerCLI
{
    Mesh mesh;

    public void loadFromM(File f)
        throws Exception
    {
        mesh = new Mesh(true);
        //mesh = new Mesh(false);

        //state of 0 means we're reading vertices
        //state of 1 means we're reading faces
        int state = 0;
        //int vhIndex = 1;
        //List vh = new ArrayList(500);
        Map vh = new HashMap();

        BufferedReader br = new BufferedReader(new FileReader(f));
        while (br.ready()) {
            String currentLine = br.readLine();
            StringTokenizer stk = new StringTokenizer(currentLine);

            if (currentLine.length() == 0) {
                continue;
            }
            String keyWord = stk.nextToken();

            if (keyWord.equals("Vertex")) {
                state = 0;
            }
            else if (keyWord.equals("Face")) {
                state = 1;
            }
            else {
                continue;
            }

            switch(state)
            {
                case 0:
                    {
                        StringTokenizer st = new StringTokenizer(currentLine);
                        //skip the keyWord 'Vertex'
                        st.nextToken();
                        String id = st.nextToken();
                        Point3d v = 
                            new Point3d(Double.parseDouble(st.nextToken()),
                                    Double.parseDouble(st.nextToken()),
                                    Double.parseDouble(st.nextToken()));

                        vh.put(new Integer(id), 
                                mesh.addVertex(v, Integer.parseInt(id)));

                        //vh.add(mesh.addVertex(v, id));
                        //vhIndex++;
                        break;
                    }
                case 1:
                    {
                        StringTokenizer st = new StringTokenizer(currentLine);
                        //skip the keyWord 'Face'
                        st.nextToken();
                        //skip the face ID
                        st.nextToken();
                        VertexHandle []face = 
                            new VertexHandle[st.countTokens()];
                        for (int a = 0; a < face.length; a++) {
                            int index = 
                                Integer.parseInt(st.nextToken());
                            face[a] = 
                                (VertexHandle)vh.get(new Integer(index));
                        }
                        try {
                            mesh.addFace(face);
                        }
                        catch (Exception e) {
                            System.out.println("fucked up trying to add " + currentLine);
                            throw e;
                        }
                        break;
                    }
            }//switch(state)
        }//while the file hasn't been all parsed yet
        br.close();
        //System.out.println("MeshLargestIndex " + mesh.getLargestHashCode());
    }

    private void loadFromObj(File f)
        throws Exception
    {
        mesh = new Mesh(true);
        //mesh = new Mesh(false);

        //state of 0 means we're reading vertices
        //state of 1 means we're reading faces
        int state = 0;
        int vhIndex = 1;
        List vh = new ArrayList(500);

        BufferedReader br = new BufferedReader(new FileReader(f));
        while (br.ready()) {
            String currentLine = br.readLine();
            StringTokenizer stk = new StringTokenizer(currentLine);

            if (currentLine.length() == 0) {
                continue;
            }
            String keyWord = stk.nextToken();

            if (keyWord.equals("v")) {
                state = 0;
            }
            else if (keyWord.equals("f")) {
                state = 1;
            }
            else {
                continue;
            }

            switch(state)
            {
                case 0:
                    {
                        StringTokenizer st = new StringTokenizer(currentLine);
                        //skip the keyWord 'v'
                        st.nextToken();
                        Point3d v = 
                            new Point3d(Double.parseDouble(st.nextToken()),
                                    Double.parseDouble(st.nextToken()),
                                    Double.parseDouble(st.nextToken()));

                        vh.add(mesh.addVertex(v, vhIndex));
                        vhIndex++;
                        break;
                    }
                case 1:
                    {
                        StringTokenizer st = new StringTokenizer(currentLine);
                        //skip the keyWord 'f'
                        st.nextToken();
                        VertexHandle []face = 
                            new VertexHandle[st.countTokens()];
                        for (int a = 0; a < face.length; a++) {
                            String vertexIndex = st.nextToken();
                            StringTokenizer vertexIndexSt =
                                new StringTokenizer(vertexIndex, "/");
                            int index = 
                                Integer.parseInt(vertexIndexSt.nextToken());
                            //since our array starts at 0, but their array 
                            //starts at 1
                            face[a] = 
                                (VertexHandle)vh.get(index - 1);
                            /*
                            face[face.length - 1 - a] = 
                                (VertexHandle)vh.get(index - 1);
                                */
                            /*
                            System.out.println("face[" + 
                                    (face.length - 1 - a) + 
                                    "] - " + 
                                    face[face.length - 1 - a].getVertex());
                                    */
                        }
                        //System.out.println("------------------------------");
                        try {
                        mesh.addFace(face);
                        }
                        catch (Exception e) {
                            System.out.println("fucked up trying to add " + currentLine);
                            throw e;
                        }
                        break;
                    }
            }//switch(state)
        }//while the file hasn't been all parsed yet
        br.close();
        //System.out.println("MeshLargestIndex " + mesh.getLargestHashCode());
    }

    private void loadFromS3D(File f)
        throws Exception
    {
        mesh = new Mesh(true);

        BufferedReader br = new BufferedReader(new FileReader(f));
        int vertexCounter = 0;
        Map vertexToVertexIndexMap = new HashMap();
        while (br.ready()) {
            String patchDefinition = br.readLine();
            if (patchDefinition.trim().equals("")) {
                continue;
            }
            StringTokenizer st = new StringTokenizer(patchDefinition);
            //We are only interested in the number of vertices
            st.nextToken();
            int numVertex = Integer.parseInt(st.nextToken());
            VertexHandle[] vertexHandle = new VertexHandle[numVertex];

            for (int a = 0; a < numVertex; a++) {
                //Skip the normal
                String vertex = br.readLine();
                st = new StringTokenizer(vertex);
                String lineType = st.nextToken();

                if (lineType.equals("n")) {
                    vertex = br.readLine();
                    //System.out.println("read in vertex - " + vertex);
                    st = new StringTokenizer(vertex);
                    //Skip the "v" prefix
                    st.nextToken();
                }

                Point3d v = 
                    new Point3d(Double.parseDouble(st.nextToken()),
                            Double.parseDouble(st.nextToken()),
                            Double.parseDouble(st.nextToken()));

                //System.out.println("parsed vertex - " + v);

                Integer vertexIndex = 
                    (Integer)vertexToVertexIndexMap.get(v.toString());
                if (vertexIndex == null) {
                    vertexToVertexIndexMap.put(v.toString(), 
                            new Integer(vertexCounter));
                    vertexIndex = new Integer(vertexCounter);
                    vertexCounter ++;
                }

                vertexHandle[a] = mesh.addVertex(v, vertexIndex.intValue());
                if (!vertexHandle[a].getVertex().equals(v)) {
                    System.out.println("v is " + v.toString());
                    System.out.println("v from the mesh is " + vertexHandle[a].getVertex());
                    throw new RuntimeException();
                    //System.out.println("shit!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
                }
            }
            mesh.addFace(vertexHandle);
            //skip the "ending" line
            br.readLine();
        }
        br.close();
    }
    
    public SubdivisionControllerCLI(File f)
        throws Exception
    {
        String fName = f.getName();

        String suffix = fName.substring(fName.lastIndexOf("."));
        System.out.println(suffix + " format detected");
        if (suffix.equals(".s3d")) {
            loadFromS3D(f);
        }
        else if (suffix.equals(".obj")) {
            loadFromObj(f);
        }
        else if (suffix.equals(".m")) {
            loadFromM(f);
        }
        else {
            throw new Exception("Unkown file type");
        }
    }

    public void printMesh()
    {
        Iterator it = mesh.faceIterator();

        int numFaces = 0;

        while (it.hasNext()) {
            Face f = (Face)it.next();
            System.out.println("Face : ");
            Iterator vIt = f.vertexIterator();
            int numVertex = 0;
            while (vIt.hasNext()) {
                VertexHandle vH = 
                    mesh.getVertexHandle(((Integer)vIt.next()).intValue());
                System.out.println("v - " + vH.getVertex());
                numVertex++;
            }
            System.out.println("total number of vertices = " + numVertex);
            System.out.println("---------------------------------------");
            numFaces++;
        }

        System.out.println("There are a total of " + numFaces + " faces");
    }

    public static void main(String[] args)
        throws Exception
    {
        String input = null;
        String output = null;
        int depth = 0;
        String className = null;
        //String output = null;
        //boolean drawNormal = false;
        
        if (args.length == 4) {
            className = args[0];
            depth = Integer.parseInt(args[1]);
            input = args[2];
            output = args[3];
            //output = args[1];
        }
        else {
            System.out.println("Usage : SubdivisionControllerCLI <sub-d algorithm class> " + 
                    "<sub-d depth> <name of " +
                    "bezier patch file> <output patch file>");
            System.exit(1);
        }

        SubdivisionControllerCLI mt = 
            new SubdivisionControllerCLI(new File(input));

        //For Testing
        //mt.printMesh();
        Mesh newMesh = mt.mesh; 
        System.out.println("The initial mesh has " +
                newMesh.numFaces() + " polygons");

        /*
        System.out.println("before sub-d analysis");
        Iterator vIt = newMesh.vertexIterator();
        while (vIt.hasNext()) {
            VertexHandle vh = newMesh.getVertexHandle(vIt.next());
            if (vh.isBoundary()) {
                Iterator vvIt = vh.vertexIterator();
                int valence = 0;
                while (vvIt.hasNext()) {
                    valence ++;
                    vvIt.next();
                }
                System.out.println("FUCK " + vh.getVertex() + 
                        " has valance " + valence + " and its boundary!!!");
            }
        }
        */
        
        /*
        for (int a = 0; a < depth; a++) {
            newMesh = LoopSubdivision.subdivide(newMesh);
        }
        */

        Class algorithm = Class.forName(className);
        SubdivisionAlgorithm subd = 
            (SubdivisionAlgorithm)algorithm.newInstance();
        
        //Root3Subdivision subd = new Root3Subdivision();
        //PetersSubdivision subd = new PetersSubdivision();
        //LoopSubdivision subd = new LoopSubdivision();
        //ModifiedButterflySubdivision subd = new ModifiedButterflySubdivision();
        for (int a = 0; a < depth; a++) {
            System.out.println("Subdividing level " + a);
            newMesh = subd.subdivide(newMesh);
            System.out.println("Mesh now has " +
                    newMesh.numFaces() + " polygons");
        }
        System.out.println("writing output");

        /*
        System.out.println("after sub-d analysis");
        vIt = newMesh.vertexIterator();
        while (vIt.hasNext()) {
            VertexHandle vh = newMesh.getVertexHandle(vIt.next());
            if (vh.isBoundary()) {
                Iterator vvIt = vh.vertexIterator();
                int valence = 0;
                while (vvIt.hasNext()) {
                    valence ++;
                    vvIt.next();
                }
                System.out.println("FUCK " + vh.getVertex() + 
                        " has valance " + valence + " and its boundary!!!");
            }
        }
        */

        newMesh.toS3D(new File(output));
    }
}
